diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
index d76558d41..9ddaa60b5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.block.model.generic.BlockModelGenericLeaves;
+import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.option.enums.LeavesQuality;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -50,14 +51,14 @@ public class BlockModelLeaves<T extends BlockLogic> extends BlockModelStandard<T
     @Override
     public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         if (this.canBeRetro && isRetro()) {
-            return BlockModelGenericLeaves.fancyGraphics ? this.retroLeavesFancy : this.retroLeaves;
+            return GameSettings.LEAVES_QUALITY.value != LeavesQuality.FAST ? this.retroLeavesFancy : this.retroLeaves;
         }
-        return BlockModelGenericLeaves.fancyGraphics ? this.fancyLeavesTexture : super.getBlockTextureFromSideAndMetadata(side, data);
+        return GameSettings.LEAVES_QUALITY.value != LeavesQuality.FAST ? this.fancyLeavesTexture : super.getBlockTextureFromSideAndMetadata(side, data);
     }
 
     @Override
     public boolean shouldSideBeRendered(@NotNull WorldSource source, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @NotNull Side side) {
-        if (!BlockModelGenericLeaves.fancyGraphics && source.getBlockType(tilePos) == this.block) {
+        if (GameSettings.LEAVES_QUALITY.value == LeavesQuality.FANCY && source.getBlockType(tilePos) == this.block) {
             return false;
         } else {
             return super.shouldSideBeRendered(source, bounds, tilePos, side);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeaves.java
index 63b4982dd..9e50ab7c1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeaves.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeaves.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.render.block.model.generic;
 
+import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.option.enums.LeavesQuality;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
@@ -12,25 +14,34 @@ import org.jetbrains.annotations.Nullable;
 import org.useless.dragonfly.models.block.StaticBlockModel;
 
 public class BlockModelGenericLeaves<T extends BlockLogic> extends BlockModelGeneric<T> {
-    public static boolean fancyGraphics;
     public @NotNull StaticBlockModel fast;
+    public @NotNull StaticBlockModel smart;
     public BlockModelGenericLeaves(@NotNull Block<T> block, @NotNull String key) {
         super(block, BlockModelDispatcher.loadDataModel(key + "_fancy"));
         this.fast = BlockModelDispatcher.loadDataModel(key + "_fast").asModel();
+        this.smart = BlockModelDispatcher.loadDataModel(key + "_smart").asModel();
     }
 
-    public static void setGraphicsLevel(boolean graphicsLevel) {
-        fancyGraphics = graphicsLevel;
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return switch (GameSettings.LEAVES_QUALITY.value) {
+            case FANCY, SMART -> this.staticModel;
+            case FAST -> this.fast;
+        };
     }
 
     @Override
-    public @NotNull StaticBlockModel getModelFromData(int data) {
-        return fancyGraphics ? super.getModelFromData(data) : this.fast;
+    public @NotNull StaticBlockModel getModel(@NotNull WorldSource source, @NotNull TilePosc tilePosc) {
+        return switch (GameSettings.LEAVES_QUALITY.value) {
+            case FANCY -> this.staticModel;
+            case SMART -> this.smart;
+            case FAST -> this.fast;
+        };
     }
 
     @Override
     public boolean cullSide(@NotNull WorldSource worldSource, @NotNull TilePosc blockPos, @Nullable Direction direction) {
-        if (fancyGraphics) {
+        if (GameSettings.LEAVES_QUALITY.value == LeavesQuality.FANCY) {
             return super.cullSide(worldSource, blockPos, direction);
         }
         if (direction != null) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSpikes.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSpikes.java
index 4c1b2bbf0..43ec5f471 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSpikes.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericSpikes.java
@@ -21,9 +21,34 @@ public class BlockModelGenericSpikes<T extends BlockLogic> extends BlockModelGen
 
     @Override
     public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
-        boolean didRender = super.renderAttached(tessellator, worldSource, tilePos, cullFaces, overrideTexture);
-        if (BlockLogicSpikes.isSpikesUp(worldSource.getBlockData(tilePos))) {
-            didRender |= this.spikes.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+        int rotX = 1;
+        int rotY = 0;
+
+        int data = worldSource.getBlockData(tilePos);
+        switch (BlockLogicSpikes.getDirectionFromData(data)) {
+            case UP -> {
+                rotX = 2;
+            }
+            case DOWN -> {
+                rotX = 0;
+            }
+            case NORTH -> {
+                rotY = 0;
+            }
+            case SOUTH -> {
+                rotY = 2;
+            }
+            case WEST -> {
+                rotY = 1;
+            }
+            case EAST -> {
+                rotY = 3;
+            }
+        }
+
+        boolean didRender = getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, rotX, rotY, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+        if (BlockLogicSpikes.isSpikesUp(data)) {
+            didRender |= this.spikes.renderAttached(this, tessellator, worldSource, tilePos, rotX, rotY, 0, 0, 0, 0, false, cullFaces, overrideTexture);
         }
         return didRender;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/camera/EntityCamera.java b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCamera.java
index 0e7bc9ce7..e993fc950 100644
--- a/game/client/src/main/java/net/minecraft/client/render/camera/EntityCamera.java
+++ b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCamera.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.camera;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.culling.CameraFrustum;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.MathHelper;
@@ -86,7 +87,7 @@ public abstract class EntityCamera
 
     @Override
     public double getFov() {
-        return this.mc.gameSettings.FoV.get();
+        return GameSettings.FOV.get();
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/culling/CameraFrustum.java b/game/client/src/main/java/net/minecraft/client/render/culling/CameraFrustum.java
index f7d88dc6a..ee5c2aeff 100644
--- a/game/client/src/main/java/net/minecraft/client/render/culling/CameraFrustum.java
+++ b/game/client/src/main/java/net/minecraft/client/render/culling/CameraFrustum.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.culling;
 
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.renderer.GLRenderer;
 import org.jetbrains.annotations.NotNull;
@@ -13,7 +14,9 @@ public class CameraFrustum {
     private static final @NotNull Matrix4f matrix4f = new Matrix4f();
 
     public static void recalcFrustrum() {
-        frustum.set(GLRenderer.projectionM4f().mul(GLRenderer.viewM4f(), matrix4f).mul(GLRenderer.modelM4f(), matrix4f));
+        if (GameSettings.FRUSTUM_CULLING.value){
+            frustum.set(GLRenderer.projectionM4f().mul(GLRenderer.viewM4f(), matrix4f).mul(GLRenderer.modelM4f(), matrix4f));
+        }
     }
 
     public static @NotNull FrustumIntersection getFrustum() {
@@ -36,6 +39,10 @@ public class CameraFrustum {
     }
 
     public boolean isVisible(@NotNull AABBdc aabb, float partialTick) {
-        return cubeInFrustum(aabb, partialTick);
+        if (GameSettings.FRUSTUM_CULLING.value) {
+            return cubeInFrustum(aabb, partialTick);
+        } else {
+            return true;
+        }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexture.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexture.java
index 71e8c9787..b1c3318b5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexture.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexture.java
@@ -1,12 +1,11 @@
 package net.minecraft.client.render.dynamictexture;
 
-import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.option.enums.TextureAnimation;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import org.jetbrains.annotations.NotNull;
 
 public abstract class DynamicTexture {
-
-	public Minecraft mc = Minecraft.getMinecraft();
 	@NotNull
 	public final IconCoordinate targetTexture;
 	public byte[] imageData;
@@ -20,11 +19,11 @@ public abstract class DynamicTexture {
 	public abstract void update();
 
 	public boolean runUpdates(boolean isPaused) {
-		return mc.gameSettings.animations.value != 0 && !isPaused;
+		return GameSettings.TEXTURE_ANIMATIONS.value != TextureAnimation.OFF && !isPaused;
 	}
 	
 	public void initTexture() {
-		this.imageData = new byte[targetTexture.width * targetTexture.height * 4];
+		this.imageData = new byte[this.targetTexture.width * this.targetTexture.height * 4];
 	}
 	
 	public static int pmod(int a, int b) {
@@ -38,7 +37,7 @@ public abstract class DynamicTexture {
 		int b = (color >>  0) & 0xFF;
 		int a = (color >> 24) & 0xFF;
 		
-		array[i * 4 + 0] = (byte) r;
+		array[i * 4] = (byte) r;
 		array[i * 4 + 1] = (byte) g;
 		array[i * 4 + 2] = (byte) b;
 		array[i * 4 + 3] = (byte) a;
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
index 1d9739ffa..05689987b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
@@ -4,6 +4,8 @@ import java.awt.image.BufferedImage;
 import java.util.Random;
 
 import com.mojang.logging.LogUtils;
+import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.option.enums.TextureAnimation;
 import net.minecraft.client.render.texture.meta.AnimationProperties;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texturepack.TexturePackException;
@@ -184,6 +186,6 @@ public class DynamicTextureCustom extends DynamicTexture {
 	}
 	@Override
 	public boolean runUpdates(boolean isPaused) {
-		return this.mc.gameSettings.animations.value != 0 && (!isPaused || this.tickWhenPaused);
+		return GameSettings.TEXTURE_ANIMATIONS.value != TextureAnimation.OFF && (!isPaused || this.tickWhenPaused);
 	}
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java
index 2e8a478b2..0b13882df 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java
@@ -14,11 +14,11 @@ public class DynamicTextureFireflyJar extends DynamicTexture {
         super(texture);
 
         this.originalData = new byte[texture.getArea() * 4];
-        int[] data = texture.parentAtlas.getIconData("color", texture, new int[texture.getArea()]);
+        BufferedImage image = texture.parentAtlas.getImage("color", texture);
 
 		for(int x = 0; x < texture.width; x++) {
 			for(int y = 0; y < texture.height; y++) {
-				putPixel(this.originalData, y * texture.width + x, data[y * texture.width + x]);
+				putPixel(this.originalData, y * texture.width + x, image.getRGB(x, y));
 			}
 		}
 	}
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
index 1d9bdfe47..94af132cc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.dynamictexture;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import org.jetbrains.annotations.NotNull;
 
@@ -21,11 +22,11 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 	@Override
 	public void postInit() {
 		initTexture();
-		
-		arr1 = new float[targetTexture.getArea()];
-		arr2 = new float[targetTexture.getArea()];
-		arr3 = new float[targetTexture.getArea()];
-		arr4 = new float[targetTexture.getArea()];
+
+        this.arr1 = new float[this.targetTexture.getArea()];
+        this.arr2 = new float[this.targetTexture.getArea()];
+        this.arr3 = new float[this.targetTexture.getArea()];
+        this.arr4 = new float[this.targetTexture.getArea()];
 	}
 
 	@Override
@@ -33,30 +34,30 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 		this.ticks++;
 
 		float bright;
-		for (int x = 0; x < targetTexture.width; ++x) {
-			for (int y = 0; y < targetTexture.height; ++y) {
+		for (int x = 0; x < this.targetTexture.width; ++x) {
+			for (int y = 0; y < this.targetTexture.height; ++y) {
 				bright = 0.0F;
 
 				for (int k = y - 2; k <= y; ++k) {
-					int r = pmod(x, targetTexture.width);
-					int g = pmod(k, targetTexture.height);
-					bright += this.arr1[r + g * targetTexture.width];
+					int r = pmod(x, this.targetTexture.width);
+					int g = pmod(k, this.targetTexture.height);
+					bright += this.arr1[r + g * this.targetTexture.width];
 				}
 
-				this.arr2[x + y * targetTexture.width] = bright / 3.2F + this.arr3[x + y * targetTexture.width] * 0.8F;
+				this.arr2[x + y * this.targetTexture.width] = bright / 3.2F + this.arr3[x + y * this.targetTexture.width] * 0.8F;
 			}
 		}
 
-		for (int x = 0; x < targetTexture.width; ++x) {
-			for (int y = 0; y < targetTexture.height; ++y) {
-				this.arr3[x + y * targetTexture.width] += this.arr4[x + y * targetTexture.width] * 0.05F;
-				if (this.arr3[x + y * targetTexture.width] < 0.0F) {
-					this.arr3[x + y * targetTexture.width] = 0.0F;
+		for (int x = 0; x < this.targetTexture.width; ++x) {
+			for (int y = 0; y < this.targetTexture.height; ++y) {
+				this.arr3[x + y * this.targetTexture.width] += this.arr4[x + y * this.targetTexture.width] * 0.05F;
+				if (this.arr3[x + y * this.targetTexture.width] < 0.0F) {
+					this.arr3[x + y * this.targetTexture.width] = 0.0F;
 				}
 
-				this.arr4[x + y * targetTexture.width] -= 0.3F;
+				this.arr4[x + y * this.targetTexture.width] -= 0.3F;
 				if (Math.random() < 0.2D) {
-					this.arr4[x + y * targetTexture.width] = 0.5F;
+					this.arr4[x + y * this.targetTexture.width] = 0.5F;
 				}
 			}
 		}
@@ -65,8 +66,8 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 		this.arr2 = this.arr1;
 		this.arr1 = var12;
 
-		for (int i = 0; i < targetTexture.getArea(); ++i) {
-			bright = this.arr1[pmod(i - this.ticks * targetTexture.width, targetTexture.getArea())];
+		for (int i = 0; i < this.targetTexture.getArea(); ++i) {
+			bright = this.arr1[pmod(i - this.ticks * this.targetTexture.width, this.targetTexture.getArea())];
 			if (bright > 1.0F) {
 				bright = 1.0F;
 			}
@@ -81,11 +82,11 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 			int b = 255;
 			int a = (int) (146.0F + var13 * 50.0F);
 
-			if (mc.gameSettings.biomeWater.value && !(mc.currentWorld != null && mc.currentWorld.isRetro())) {
+			if (GameSettings.BIOME_WATER.value && !(this.mc.currentWorld != null && this.mc.currentWorld.isRetro())) {
 				r = g = b = (r + g + b) / 3;
 			}
 
-			this.imageData[i * 4 + 0] = (byte) r;
+			this.imageData[i * 4] = (byte) r;
 			this.imageData[i * 4 + 1] = (byte) g;
 			this.imageData[i * 4 + 2] = (byte) b;
 			this.imageData[i * 4 + 3] = (byte) a;
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
index 24bdb87e1..07c381ba6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.dynamictexture;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 
 public class DynamicTextureWaterStill extends DynamicTexture {
@@ -20,10 +21,10 @@ public class DynamicTextureWaterStill extends DynamicTexture {
 	public void postInit() {
 		initTexture();
 
-		arr1 = new float[targetTexture.getArea()];
-		arr2 = new float[targetTexture.getArea()];
-		arr3 = new float[targetTexture.getArea()];
-		arr4 = new float[targetTexture.getArea()];
+        this.arr1 = new float[this.targetTexture.getArea()];
+        this.arr2 = new float[this.targetTexture.getArea()];
+        this.arr3 = new float[this.targetTexture.getArea()];
+        this.arr4 = new float[this.targetTexture.getArea()];
 	}
 
 	@Override
@@ -32,30 +33,30 @@ public class DynamicTextureWaterStill extends DynamicTexture {
 		float bright;
 		int a_;
 		int b_;
-		for (int x = 0; x < targetTexture.width; ++x) {
-			for (y = 0; y < targetTexture.height; ++y) {
+		for (int x = 0; x < this.targetTexture.width; ++x) {
+			for (y = 0; y < this.targetTexture.height; ++y) {
 				bright = 0.0F;
 
 				for (int k = x - 1; k <= x + 1; ++k) {
-					a_ = pmod(k, targetTexture.width);
-					b_ = pmod(y, targetTexture.height);
-					bright += this.arr1[a_ + b_ * targetTexture.width];
+					a_ = pmod(k, this.targetTexture.width);
+					b_ = pmod(y, this.targetTexture.height);
+					bright += this.arr1[a_ + b_ * this.targetTexture.width];
 				}
 
-				this.arr2[x + y * targetTexture.width] = bright / 3.3F + this.arr3[x + y * targetTexture.width] * 0.8F;
+				this.arr2[x + y * this.targetTexture.width] = bright / 3.3F + this.arr3[x + y * this.targetTexture.width] * 0.8F;
 			}
 		}
 
-		for (int x = 0; x < targetTexture.width; ++x) {
-			for (y = 0; y < targetTexture.height; ++y) {
-				this.arr3[x + y * targetTexture.width] += this.arr4[x + y * targetTexture.width] * 0.05F;
-				if (this.arr3[x + y * targetTexture.width] < 0.0F) {
-					this.arr3[x + y * targetTexture.width] = 0.0F;
+		for (int x = 0; x < this.targetTexture.width; ++x) {
+			for (y = 0; y < this.targetTexture.height; ++y) {
+				this.arr3[x + y * this.targetTexture.width] += this.arr4[x + y * this.targetTexture.width] * 0.05F;
+				if (this.arr3[x + y * this.targetTexture.width] < 0.0F) {
+					this.arr3[x + y * this.targetTexture.width] = 0.0F;
 				}
 
-				this.arr4[x + y * targetTexture.width] -= 0.1F;
+				this.arr4[x + y * this.targetTexture.width] -= 0.1F;
 				if (Math.random() < 0.05D) {
-					this.arr4[x + y * targetTexture.width] = 0.5F;
+					this.arr4[x + y * this.targetTexture.width] = 0.5F;
 				}
 			}
 		}
@@ -64,7 +65,7 @@ public class DynamicTextureWaterStill extends DynamicTexture {
 		this.arr2 = this.arr1;
 		this.arr1 = var12;
 
-		for (int i = 0; i < targetTexture.getArea(); ++i) {
+		for (int i = 0; i < this.targetTexture.getArea(); ++i) {
 			bright = this.arr1[i];
 			if (bright > 1.0F) {
 				bright = 1.0F;
@@ -80,11 +81,11 @@ public class DynamicTextureWaterStill extends DynamicTexture {
 			int b = 255;
 			int a = (int) (146.0F + var13 * 50.0F);
 
-			if (mc.gameSettings.biomeWater.value && !(mc.currentWorld != null && mc.currentWorld.isRetro())) {
+			if (GameSettings.BIOME_WATER.value && !(this.mc.currentWorld != null && this.mc.currentWorld.isRetro())) {
 				r = g = b = (r + g + b) / 3;
 			}
 
-			this.imageData[i * 4 + 0] = (byte) r;
+			this.imageData[i * 4] = (byte) r;
 			this.imageData[i * 4 + 1] = (byte) g;
 			this.imageData[i * 4 + 2] = (byte) b;
 			this.imageData[i * 4 + 3] = (byte) a;
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
index c01ecfd26..6f760dfcb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
@@ -1,11 +1,11 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.pos.TilePos;
@@ -313,7 +313,7 @@ public abstract class EntityRenderer<T extends Entity> {
     }
 
     public void postRender(final @NotNull TessellatorGeneral tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
-        if (renderShadows && this.renderDispatcher.settings.fancyGraphics.value == 1 && getShadowSize(entity) > 0.0F) {
+        if (renderShadows && GameSettings.ENTITY_SHADOWS.value && getShadowSize(entity) > 0.0F) {
             final double distance = this.renderDispatcher.distanceToLerpSquared(entity.x, entity.y, entity.z);
             final float opacity = (float) ((1.0D - distance / 256D) * (double) this.shadowOpacity);
             if (opacity > 0.0F) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
index 57a967328..7f6126c30 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.renderer.DrawMode;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
@@ -31,7 +32,7 @@ public class EntityRendererFishingBobber extends EntityRendererSprite<EntityFish
             double xp = MathHelper.lerp(entity.owner.xo, entity.owner.x, partialTick) + vec3.x;
             double yp = MathHelper.lerp(entity.owner.yo, entity.owner.y, partialTick) + entity.owner.getHeadHeight() + vec3.y;
             double zp = MathHelper.lerp(entity.owner.zo, entity.owner.z, partialTick) + vec3.z;
-            if (this.renderDispatcher.settings.thirdPersonView.value > 0) {
+            if (GameSettings.THIRD_PERSON_VIEW.value > 0) {
                 float rr = ((entity.owner.yBodyRotO + (entity.owner.yBodyRot - entity.owner.yBodyRotO) * partialTick) * MathHelper.PI) / 180F;
                 double ss = MathHelper.sin(rr);
                 double cc = MathHelper.cos(rr);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
index 58e1e346d..11e8c3ac3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.entity.EntityItem;
 import org.jetbrains.annotations.NotNull;
@@ -37,7 +37,7 @@ public class EntityRendererItem extends EntityRenderer<EntityItem> {
             renderCount = 4;
         }
         GLRenderer.modelM4f().translate((float) x, (float) (y + bobbingOffset), (float) z);
-        ItemModelDispatcher.getInstance().getDispatch(item).renderItemEntity(tessellator, itemstack, Minecraft.getMinecraft().gameSettings.items3D.value, renderCount, entity.age, yw, entity.getLightmap(partialTick), partialTick);
+        ItemModelDispatcher.getInstance().getDispatch(item).renderItemEntity(tessellator, itemstack, GameSettings.ITEMS_3D.value, renderCount, entity.age, yw, entity.getLightmap(partialTick), partialTick);
         GLRenderer.popFrame();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index e79f8b6cc..ffc89c256 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.entity;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.CompareFunc;
@@ -225,7 +226,7 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T> {
     }
 
     public void loadEntityTexture(final @NotNull T entity) {
-        if (!Minecraft.getMinecraft().gameSettings.mobVariants.value) {
+        if (!GameSettings.MOB_VARIANTS.value) {
             bindTexture(entity.getDefaultEntityTexture());
         } else {
             bindTexture(entity.getEntityTexture());
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java
index e5b64674c..a3a303683 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
@@ -73,7 +73,7 @@ public class MobRendererButterfly extends EntityRenderer<MobButterfly> {
     }
 
     public static String getTexture(final MobButterfly butterfly) {
-        if (!Minecraft.getMinecraft().gameSettings.mobVariants.value) {
+        if (!GameSettings.MOB_VARIANTS.value) {
             return butterfly.getDefaultEntityTexture();
         } else {
             return butterfly.getEntityTexture();
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index 4848aefe5..8c931876f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.PlayerSkinParser;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
@@ -113,7 +114,7 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player> {
         if (mc.thePlayer.getGamemode() != Gamemodes.SPECTATOR && entity.getGamemode() == Gamemodes.SPECTATOR) {
             return;
         }
-        if (mc.gameSettings.immersiveMode.drawNames() && mc.activeCamera != null) // Render name
+        if (GameSettings.IMMERSIVE_MODE.drawNames() && mc.activeCamera != null) // Render name
         {
             if (mc.activeCamera instanceof EntityCamera entityCamera && entityCamera.mob == entity) {
                 return;
@@ -317,7 +318,7 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player> {
         }
 
         public static @Nullable Specials getSpecialsForPlayer(final @NotNull Player player) {
-            if (!Minecraft.getMinecraft().gameSettings.devModels.value || !player.playerConfig.devModelEnabled())
+            if (!GameSettings.DEV_MODELS.value || !player.playerConfig.devModelEnabled())
                 return null;
             if (player.uuid.equals(SHIGN.uuid) || player.username.equals(SHIGN.username)) return SHIGN;
             if (player.uuid.equals(COOKIE.uuid) || player.username.equals(COOKIE.username)) return COOKIE;
@@ -328,7 +329,7 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player> {
         }
 
         public static @Nullable Specials getSpecialsForMob(final @NotNull Mob mob) {
-            if (!Minecraft.getMinecraft().gameSettings.devModels.value) return null;
+            if (!GameSettings.DEV_MODELS.value) return null;
             if (mob.nickname.equals(SHIGN.username)) return SHIGN;
             if (mob.nickname.equals(COOKIE.username)) return COOKIE;
             if (mob.nickname.equals(THA_BOAR.username)) return THA_BOAR;
